package com.miauw.app_management.in_app_update

import android.app.Activity
import com.google.android.play.core.appupdate.AppUpdateManager
import android.content.Context
import com.google.android.gms.tasks.Task
import com.google.android.play.core.appupdate.AppUpdateInfo
import com.google.android.play.core.appupdate.AppUpdateManagerFactory
import com.google.android.play.core.install.InstallState
import com.google.android.play.core.install.InstallStateUpdatedListener
import com.google.android.play.core.install.model.AppUpdateType
import com.google.android.play.core.install.model.InstallStatus
import com.google.android.play.core.install.model.UpdateAvailability
import io.flutter.plugin.common.MethodChannel

class InAppUpdate {
    var appUpdateInfoTask : Task<AppUpdateInfo>? = null
    var appUpdateManager : AppUpdateManager? = null
    var activitys : Activity? = null
    var contexts : Context? = null
    lateinit var  methodChannels: MethodChannel

    val listener = InstallStateUpdatedListener { state ->
        // (Optional) Provide a download progress bar.
        if (state.installStatus() == InstallStatus.DOWNLOADING) {
            val bytesDownloaded = state.bytesDownloaded()
            val totalBytesToDownload = state.totalBytesToDownload()
            methodChannels.invokeMethod("update_progress", bytesDownloaded.toString() + '|' + totalBytesToDownload.toString())
        }
        else if (state.installStatus() == InstallStatus.DOWNLOADED) {
            methodChannels.invokeMethod("update_status", "DOWNLOADED")
            appUpdateManager!!.completeUpdate()

        }else if (state.installStatus() == InstallStatus.INSTALLED){
            methodChannels.invokeMethod("update_status", "INSTALLED")
            unregister()
        }else if(state.installStatus() == InstallStatus.FAILED){
            methodChannels.invokeMethod("update_status", "FAILED")
            unregister()
        }
    }

    fun unregister(){
        if(appUpdateManager != null){
            appUpdateManager!!.unregisterListener(listener)
            if(activitys != null && contexts != null){

                activitys!!.finish();
                contexts!!.startActivity(activitys!!.intent)
            }
        }

    }


    fun check(context: Context,activity: Activity,methodChannel : MethodChannel){
        methodChannels = methodChannel
        contexts = context
        activitys = activity
        appUpdateManager = AppUpdateManagerFactory.create(context)

        // Returns an intent object that you use to check for an update.
        appUpdateInfoTask = appUpdateManager!!.appUpdateInfo

        appUpdateInfoTask!!.addOnFailureListener { fail->println(fail.message) }

        // Checks that the platform will allow the specified type of update.
        appUpdateInfoTask!!.addOnSuccessListener { appUpdateInfo ->
            if (appUpdateInfo.updateAvailability() == UpdateAvailability.UPDATE_AVAILABLE

            ) {
                runs(appUpdateManager!!,appUpdateInfo,activity)

            }else{
                println(appUpdateInfo.updateAvailability())

            }

        }
    }

    fun runs(appUpdateManager : AppUpdateManager,appUpdateInfo : AppUpdateInfo, activity: Activity){
        appUpdateManager.registerListener(listener)

        appUpdateManager.startUpdateFlowForResult(
            // Pass the intent that is returned by 'getAppUpdateInfo()'.
            appUpdateInfo,
            // Or 'AppUpdateType.FLEXIBLE' for flexible updates.
            AppUpdateType.FLEXIBLE,
            // The current activity making the update request.
            activity,
            // Include a request code to later monitor this update request.
            1)


    }
}